#include <iostream>
#include "pgrutils.h"

// 1394 Driver header files
#include <dc1394/utils.h>
#include <dc1394/control.h>
#include <dc1394/conversions.h>

#include "camClass.h"

#define PI 3.14159265

using namespace std;


int main(int argc, const char **argv)
{    
    dc1394error_t   cur_status;
    char            line[50];
        
	CamClass *cams=new CamClass();
	
	cur_status=cams->init();	
    if ( cur_status != DC1394_SUCCESS )
    {
        cerr << "Could not initialize all cameras" << endl;
        cams->cleanup();
        return -1;
    }
    cout << "Initialized cameras" << endl;

	cur_status=cams->setAllCameraRegisters(100000);
    if ( cur_status != DC1394_SUCCESS )
    {
        cerr << "Could not set ALL cameras registers" << endl;
        cams->cleanup();
        return -1;
    }
    cout << "Set registers" << endl;

    cout << "Ready to capture data" << endl;
    cout << "Press <letter> <ENTER> to obtain a new set of data from laser and cameras" << endl;
    cout << "Press <q|Q> to quit" << endl; 
    cin >> line;
    //////////////////////////////////////////////////////////////////
    //                          MAIN LOOP                           //
    //////////////////////////////////////////////////////////////////
    while ( (line[0]!='q') && (line[0]!='Q') )
    {
	
    	cur_status=cams->triggerAllCameras();
        if ( cur_status != DC1394_SUCCESS )
        {
            cerr << "Could not trigger ALL cameras registers" << endl;
            cams->cleanup();
            return -1;
        }
    	cout << "Triggered cameras" << endl;

        cin >> line;
    }
    cams->cleanup();
	return 0;

    //cleanup();
    return 0;
}
