function convert_image_dir_to_single_format(dir_name, max_dim)

num_imgs = 1;
files    = dir(dir_name);

for i = 1:length(files)
    
    % Ignore directories
    if (files(i).isdir)
        continue;
    end
    
    file_name = files(i).name;
    [pathstr,name,ext,versn] = fileparts(file_name);

     
    % Read in the image, ignore if cannot
    try
        % Check extension is gif
        if (strcmp('.gif',ext))
            [im map] = imread([dir_name '/' file_name]);
            img = ind2rgb(im,map);
        else
            img = imread([dir_name '/' file_name]);
        end

        % Resize the image to maximum allowed dimension
        r = size(img,1);
        c = size(img,2);
        
        if (r>c)
            if (r>max_dim)
                img = imresize(img,max_dim/r);
            end
        else
            if (c>max_dim)
                img = imresize(img,max_dim/c);
            end
        end

        imwrite(img, [dir_name '/' name '.jpg']);
        
    catch
        fprintf('Error converting %s to standard format: %s\n', file_name, lasterr);
        continue;
    end
    
    % Increase image count
    num_imgs = num_imgs + 1;
    
end
