function convert_image_to_single_format(file_name, max_dim)

[pathstr,name,ext,versn] = fileparts(file_name);

% Read in the image, ignore if cannot
try
    % Check extension is gif
    if (strcmp('.gif',ext))
        [im map] = imread(file_name);
        img = ind2rgb(im,map);
    else
        img = imread(file_name);
    end

    % Resize the image to maximum allowed dimension
    r = size(img,1);
    c = size(img,2);

    if (r>c)
        if (r>max_dim)
            img = imresize(img,max_dim/r);
        end
    else
        if (c>max_dim)
            img = imresize(img,max_dim/c);
        end
    end

    imwrite(img, [pathstr, '/' name '.jpg']);

catch
    fprintf('Error converting %s to standard format: %s\n', file_name, lasterr);
end
