function [mx1, my1, mx2, my2] = match_sift_features(sift_descs1, sift_descs2, distRatio)
% Assumes descriptors are normalized
x1s  = sift_descs1.xs;    x2s = sift_descs2.xs;
y1s  = sift_descs1.ys;    y2s = sift_descs2.ys;
des1 = sift_descs1.des;  des2 = sift_descs2.des;

if (~exist('distRatio', 'var'))
    distRatio = 0.8;
end

match = [];
if (min(size(des1,1), size(des2,1))>4)
% Code from Lowe (approximates L2 dist with dot prod)
des2t = des2';   
for i = 1 : size(des1,1)
   dotprods = des1(i,:) * des2t; 
   [vals,indx] = sort(acos(dotprods));  

   % Check if nearest neighbor has angle less than distRatio times 2nd.
   if (vals(1) < distRatio * vals(2))
      match(i) = indx(1);
   else
      match(i) = 0;
   end
end
end

% Return xy locations
matched_inds = find(match);
mx1 = x1s(matched_inds)';
my1 = y1s(matched_inds)';
mx2 = x2s(match(matched_inds))';
my2 = y2s(match(matched_inds))';


