function [mx1, my1, mx2, my2, num_unq] = match_sift_features2(sift_descs1, sift_descs2, distRatio)
% Assumes descriptors are normalized
x1s  = sift_descs1.xs;    x2s = sift_descs2.xs;
y1s  = sift_descs1.ys;    y2s = sift_descs2.ys;
des1 = sift_descs1.des;  des2 = sift_descs2.des;

if (~exist('distRatio', 'var'))
    distRatio = 0.8;
end

match = [];
if (min(size(des1,1), size(des2,1))>4)
% Code from Lowe (approximates L2 dist with dot prod)
des2t = des2';   
dotprods = acos(des1*des2t);
[d1,inds] = min(dotprods,[],2);
dotprods(sub2ind(size(dotprods), [1:size(dotprods,1)]', inds))=inf;
[d2,i] = min(dotprods,[],2);
match = d1./d2<distRatio;
match = match.*inds(:,1);
end
% Return xy locations
matched_inds = find(match);
mx1 = x1s(matched_inds)';
my1 = y1s(matched_inds)';
mx2 = x2s(match(matched_inds))';
my2 = y2s(match(matched_inds))';

% Ideally we should match the other way round
% and take consistent matches, but not doing
% so to save time
num_unq = length(unique(match(matched_inds)));
[junk,inds] = unique(match(matched_inds));
mx1 = mx1(inds);
my1 = my1(inds);
mx2 = mx2(inds);
my2 = my2(inds);
