function img_descs = pre_process_image(img)

img_descs.img_name = '';
img_descs.img_url  = '';

% If given name, read in the image
if (isstr(img))
    img_descs.img_name = img;
    
    % Replace with a more intelligent function (shud not crash
    % if file does not exist, 10,10 for imwrite
    try
        img = imread(img);
    catch
        img = zeros(10,10);
    end
end

img_descs.img = img;

% If RGB, convert to grayscale
if (ndims(img)==3)
    img_descs.imgg = rgb2gray(img);
else
    img_descs.imgg = img;
end

% Precompute sift and mser features
img_descs.dog_sift  = get_sift_features(img_descs.img, 'sift');
img_descs.mser_sift = get_sift_features(img_descs.img, 'mser');




