function [obj_list] = read_input_file(file_name)

% Read in input file and guess whether it is an 'instance'
% or a 'category' problem
obj_names = textread(file_name,'%s','delimiter','\n');

for i = 1:length(obj_names)
    obj_list{i}.name = obj_names{i};
    obj_list{i}.type = guess_object_type(obj_names{i});
    obj_list{i}.dir = ['google_object_' num2str(i)];
end





function obj_type = guess_object_type(obj_name)

    % If there is a ".." in the object name
    if (strfind(obj_name,'"'))
        obj_type = 'instance';
        return;
    end
    
    % or the object name begins with uppercase
    if (obj_name(1) < 'a')
        obj_type = 'instance';
        return;
    end
    
    % its an 'instance', else its a 'category'
    obj_type = 'category';
    








