function [obj_list, noun_type_list]= read_input_txt(input_filename)

obj_list = cell(0);

fid =fopen(input_filename);

if fid <0
    disp(['reading input text file: ' input_filename ' error!']);
    return;
end;

next_line = 0;
disp('warning: all input text will be considered as general nouns at this moment');

while 1
    tline = fgetl(fid);
    if tline == -1
        break;4
    end;
    next_line = next_line +1;
    len = length(tline);

    [isSpecialObj,special_words] = check_special_object(tline,'book');
    if isSpecialObj
        noun_type_list(next_line) = 2;
        obj_list{next_line} = special_words;
        continue;
    end;
    [isSpecialObj,special_words] = check_special_object(tline,'cd');
    if isSpecialObj
        noun_type_list(next_line) = 2;
        obj_list{next_line} = special_words;
        continue;        
    end;    
    [isSpecialObj,special_words] = check_special_object(tline,'poster');
    if isSpecialObj
        noun_type_list(next_line) = 2;
        obj_list{next_line} = special_words;
        continue;
    end;        
    
    if isempty(regexp(tline(1),'[A-Z]'))        
        noun_type_list(next_line) = 1;        
    else
        noun_type_list(next_line) = 3;
    end;

    obj_list{next_line} = tline;    
            
    %% currently, all nouns are considered as general
    %% 1 for general noun; 2 for books, CDs, posters; 3 for proper noun; 
end;

return;

%% ----------------------------
function [isSpecialObj,special_words] = check_special_object(tline,pattern)

isSpecialObj = 0;
special_words = [''];

len = length(tline);
pattern_len = length(pattern);
if len < pattern_len+1
    return;
end;

if strcmp(lower(tline(1:pattern_len+1)),[pattern ' '])
    isSpecialObj = 1;
    k = strfind(tline,'"');
    if length(k) == 2
        special_words = tline(k(1)+1:k(2)-1);                
    else
        special_words = tline(pattern_len+2:len);
    end;
end;


