function rec_desc =  recognize_object(obj_list, bot_list , idx)

% Initialize return value
rec_desc.is_recognized = false;
rec_desc.rec_img_name  = '';
rec_desc.bbox          = [0 0 0 0];
rec_desc.rec_url       = '';

% For each image from the robot
for i = 1:length(bot_list.desc)

    bot_desc = bot_list.desc{i};

    %load(['bot_descs/bot_desc_' num2str(i)],'bot_desc');
%    fprintf('Looking for %s in %s\n', obj_list.name, bot_desc.img_name);

    % Run the relevant recognition algorithm
    switch (obj_list.type)
    
        case 'instance'
            cur_rec_desc = recognize_object_instance(obj_list.desc{idx}, bot_desc, false);
        
        case 'category'
            cur_rec_desc = recognize_object_category(obj_list.desc, bot_desc);

    end    

    % Dont do anything if no object recognized
    if (~cur_rec_desc.is_recognized)
        continue;
    end
    
    % Retain match with bigger bounding box (use confidence/quality?)
    if (prod(rec_desc.bbox(3:4)) < prod(cur_rec_desc.bbox(3:4)))
        rec_desc = cur_rec_desc;
    end

    %clear bot_desc
end

