#!c:\\perl\\bin
use strict;

#########################################
# Process command-line arguments: 	#
# The first argument is the maximum 	#
# number of images to download, while	#
# the rest are the keywords.		#
######################################### 
#print STDOUT "$#ARGV\n";

die "No Keywords for image search were defined\n" unless $#ARGV>0;



#########################################
# Construct the url/search string for 	#
# Yahoo images				#
#########################################
my $prefixURL='http://images.google.com/images?hl=en&q=';
my $suffixURL='&start=';
#my $prefixURL='http://images.search.yahoo.com/search/images?p=';
#my $suffixURL='&fr=yfp-t-501&toggle=1&cop=mss&ei=UTF-8&b=';
my $imageNo=0;

my $iter;

my $maxNumberOfImagesInput=$ARGV[0];

my $directoryString=$ARGV[1];
my $keywordString=$ARGV[2];
for ($iter=3; $iter<$#ARGV+1; $iter++)
{
#	print STDOUT "$iter: $ARGV[$iter]\n";
	$keywordString=$keywordString . '+' . $ARGV[$iter];
#	$directoryString= $directoryString . '_' . $ARGV[$iter];
}

print STDOUT "$keywordString\n";

# Final url string construction

my $url=$prefixURL . $keywordString . $suffixURL . $imageNo;

#print STDOUT "$url\n";

use LWP 5.64;

my $browser = LWP::UserAgent->new;
$browser->agent('Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.0.9) Gecko/20070103');

########################################################
# Send the url to Google webpage and get the response	
########################################################
my $response = $browser->get( $url); # , @ns_headers );
die "Can't get $url -- ", $response->status_line
   	unless $response->is_success;
   	
#print STDOUT $response->decoded_content;   	

#################################################################
# Get the number of images and the maximum number of images	#
#################################################################
my $initialImageNo;
my $finalImageNo;
my $maxNumberOfImagesFound;
if ($response->decoded_content =~ /lowerLimit>(\d+)[\w\W]+ - [\w\W]+upperLimit>(\d+)[\w\W]+\s+of\s+about\s+[\w\W]+maxLimit>(\d+[,.]\d+|\d+)/) #(d+) - (\d+) of about (\d+)/)
{
	$initialImageNo = $1; 
	$initialImageNo =~ s\[,.]\\;
	$finalImageNo = $2;
	$finalImageNo =~ s\[,.]\\;
	$maxNumberOfImagesFound = $3;
	$maxNumberOfImagesFound =~ s\[,.]\\;
#	print "$initialImageNo\t,$finalImageNo\t," . sprintf("%u",$maxNumberOfImagesFound+5) ."\n";
} else	
{ 
	die "Cannot get the maximum number of images\n"; 
}

my $maxNumberOfImages;
if (($maxNumberOfImagesInput+5)<($maxNumberOfImagesFound+5)) { $maxNumberOfImages=$maxNumberOfImagesInput;} 
else {$maxNumberOfImages=$maxNumberOfImagesFound;}
print STDOUT "$maxNumberOfImagesFound images found. Will download $maxNumberOfImages images from yahoo\n"; 

my @imageArrayType;
my @imageArrayURL;
###################################################
# Visit all the URLs and retrieve the images	
###################################################
do {

	# Construct the new url	
	my $url=$prefixURL . $keywordString . $suffixURL . $imageNo;
		
	########################################################
	# Send the url to Google webpage and get the response	
	########################################################
	my $response = $browser->get( $url); # , @ns_headers );
	die "Can't get $url -- ", $response->status_line
	   	unless $response->is_success;
	
	#########################
	# SPLIT THE OUTPUT	#
	#########################
#	my @extlines=split('<a\s', $response->decoded_content);
	my @extlines=split(';', $response->decoded_content);
	my $extstring;

	foreach $extstring (@extlines)
	{
#		if ($extstring =~ /dyn.Img\("[\w\W]+","[\w\W]*","[\w\W]*","(http://[\w\W]+.([\w\W]+))",[\w\W]+\)/ )
		if ($extstring =~ /dyn.Img\("[\w\W]+","[\w\W]*","[\w\W]+","(http:\/[\w\W]+\.([\w\W]{3}))","\d+","\d+",[\w\W]+\)/)
		{
			$imageArrayType[$#imageArrayType+1]=$2;
			$imageArrayURL[$#imageArrayURL+1]= URLDecode($1);
			print STDOUT "$imageArrayType[$#imageArrayType]\t$imageArrayURL[$#imageArrayURL]\n";
		}
	}
	
#	foreach $extstring (@extlines)
#	{
#		if ($extstring =~ /type=(\w+)%[\w\W]+"Go to fullsize image"\n\ssrc="(\S+\/image\/\S+)"/)
#		{
#			$imageArrayType[$#imageArrayType+1]=$1;
#			$imageArrayURL[$#imageArrayURL+1]=$2;
##			print STDOUT "$1\t $2\n";
#		}
#	}
	if ($response->decoded_content =~ /lowerLimit>(\d+)[\w\W]+ - [\w\W]+upperLimit>(\d+)[\w\W]+\s+of\s+about\s+[\w\W]+maxLimit>(\d+[,.]\d+|\d+)/) #(d+) - (\d+) of about (\d+)/)
	{
		$finalImageNo = $2;
		$finalImageNo =~ s\[,.]\\;
		$imageNo=$finalImageNo-1;
	}
	else
	{
		$imageNo=$#imageArrayType+2;
		$finalImageNo=$imageNo+1;
	}
		
#	$imageNo=$#imageArrayType+2;
	#print $imageNo . "\n";
#     print $finalImageNo;
#print $maxNumberOfImages;

} while ($finalImageNo<$maxNumberOfImages);


#######################
# Print all the urls and types found so far
#for (my $iter=0; $iter<=$#imageArrayURL; $iter++)
#{
#	print STDOUT $iter . "\t" . $imageArrayType[$iter] . "\t" . $imageArrayURL[$iter] . "\n";
#}

#########################################
# Load the image format associations	#
#########################################
#open FORMATINPUT,"imageformats.txt" or die "Can't open file \n";
#my @formatslines=<FORMATINPUT>;
#my $formatline;
#my %formats;
#
#foreach $formatline (@formatslines)
#{
#	if ($formatline =~ /(\w+)\s+(\w+)/) {
#		$formats{$1}= $2;
##		print STDOUT "Format:$1\tExtension:$2\n";
#	}
#}
#close FORMATINPUT;

###############################################
# Create a new directory to store the images, using the keywords
# (first check if such a directory already exists)
###############################################


if (-d $directoryString)
{
	# Only change the current directory to $directory
	chdir ($directoryString);
}
else 
{
	# Create a new directory and change the path to that directory
	mkdir ($directoryString, 0777);
	chdir ($directoryString);
}	


#########################################################
# Download each image and store it to the new directory
#########################################################
my $imageString;
#for (my $iter=0; $iter<=$#imageArrayURL; $iter++)
for (my $iter=0; $iter<=$maxNumberOfImages-1; $iter++)
{	
	$url=$imageArrayURL[$iter];
	
	my $response = $browser->get( $url); # , @ns_headers );
	if ($response->is_success)
	{	
	#	print "$formats{$imageArrayType[$iter]}\t";
		# Now to save the image to disk
		$imageString='google_' . $directoryString . '_' . $iter . '.' . $imageArrayType[$iter];
	        print "Storing image $imageString...";
		open(IMAGE, ">$imageString") || die"$imageString: $!";
		binmode IMAGE;  # for MSDOS derivations.
		print IMAGE $response->content;
		close IMAGE;
		print "done\n";
#		sleep(5);
	}
	else
	{
		print "Cannot get image from URL:$url. Error:$response->status_line\n";
            $maxNumberOfImages++;
		sleep(1);

	}
}

=for comment

#################################################################
#open URLOUTPUT,">sourceURL.txt";
##open OUTPUT1,">imageURLs.txt";
# 
#print URLOUTPUT $response->decoded_content;
#close URLOUTPUT;
#
#
#open URLFILE, "sourceURL.txt";
#my @urlcontent=<URLFILE>;
##@urlcontent=<$response->decoded_content>;
#
#my $iter=1;
#my $urlline;
#foreach $urlline (@urlcontent)
#{
##	if ($urlline =~ /\ssrc="(\S+)"/) {
#	if ($urlline =~ /^\ssrc="(\S+\/image\/\S+)"/) {
#		print STDOUT "$1\n";
#		
#		# Get the image from the corresponding url
#		$response=$browser->get($1);
#		die "Can't get $url -- ", $response->status_line
#			unless $response->is_success;
#
##		$response->grab;	
#		
#		# Now to save the image to disk
#		my $imageString="image$iter.jpg";
#		print "$imageString\n";
#		open(IMAGE, ">$imageString") || die"$imageString: $!";
#		binmode IMAGE;  # for MSDOS derivations.
#		print IMAGE $response->content;
#		close IMAGE;
#		$iter=$iter+1;
#		sleep(5);
#	}
#}
#
##if ($response->decoded_content =~ /\d+\s-\s\d+\sof about\s(\d+)/) {
##	print STDOUT $1;
##}
#
##if ($response->decoded_content =~ /\s"Go to fullsize image" src="(\S+)"/) {

=cut

sub URLDecode {
	my $theURL = $_[0];
	$theURL =~ tr/+/ /;
	$theURL =~ s/%([a-fA-F0-9]{2,2})/chr(hex($1))/eg;
	$theURL =~ s/%([a-fA-F0-9]{2,2})/chr(hex($1))/eg;
    	$theURL =~ s/<!--(.|\n)*-->//g;
	return $theURL;
}

###########################################
# OBSOLETE CODE	
###########################################
# Construct the url for the images
#my $url = 'http://www.images.google.com/images?hl=en&q=blue+dry+erase+marker&btnG=Search+Images';
#my $url = 'http://www.google.com/';
#my $url='http://images.google.com/images?q=apple';
#my $url='http://images.google.com/imghp?ie=UTF-8&oe=UTF-8&hl=en&tab=wi&q=apple+cake&start=0&filter=0&safe=active';
#my $url='http://images.google.com/images?ie=UTF-8&oe=UTF-8&hl=en&tab=wi&q=apple+cake&start=0&filter=0&safe=active&btnG=Search+Images';
#my $url= 'http://images.search.yahoo.com/search/images?p=blue+dry+erase+marker&fr=yfp-t-501&toggle=1&cop=mss&ei=UTF-8&b=1';

#my @ns_headers = ( 'User-Agent' => 'Mozilla/4.76 [en] (Win98; U)');
#my @ns_headers = ( 'User-Agent' => 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.0.9) Gecko/20070103');

#$browser->agent('Mozilla/4.76 [en] (Win98; U)');
